%coded by Feifei Li, contact: lifeifei@cs.bu.edu

function [udb] = cor_normal(N, scorescale, cor)
%mu: mean, 1xd; sigma, covariance matrix, dxd
%for exmple: mu=[0,0]; sigma=[1 0.5; 0.5 1];
%varscore=devscore*devscore;
avg=0.5;
sigma=0.7;

score = avg+sigma.*randn(10*N,1);
confidence = avg+sigma.*randn(10*N,1);
confidence = score*cor+confidence*sqrt(1-cor*cor);
X=[score, confidence];
X=X( X(:,2)>0.0 & X(:,2)<=1, :);
tmpsize=size(X);
if (tmpsize(1,1)<N)
    printf('ERROR!!! Increase c value in c*N!!!');
    return;
end
X=X(1:N,:);
X(:,1)=ceil(X(:,1).*scorescale);
minscore=min(X(:,1));
X(:,1)=X(:,1)+abs(minscore)+1;
id = [1:N];
%confidence = X(:,2)/2;
%udb=[id', tmpdata(:,1), tmpdata(:,2)];
%tmpudb=[tmpdata(:,1), tmpdata(:,2)];
X=sortrows(X, [-1 -2]);
udb=[id', X(:,1), X(:,2)];
output=sprintf('cor_%d_%1.2f',N,cor);
fid = fopen(output, 'wt');
fprintf(fid, '%8.0f %8.0f %1.4f\n', udb');
fclose(fid);