%coded by Feifei Li, contact: lifeifei@cs.bu.edu

function [udb] = cor_normal_xtuple(N, scorescale, cor, numxtuple, xdegree)

avg=0.5;
sigma=0.7;

score = avg+sigma.*randn(10*N,1);
confidence = avg+sigma.*randn(10*N,1);
confidence = score*cor+confidence*sqrt(1-cor*cor);
X=[score, confidence];
%mean(X)
%var(X)

X=X( X(:,2)>0.0 & X(:,2)<=1, :);
tmpsize=size(X);
if (tmpsize(1,1)<N)
    printf('ERROR!!! Increase c value in c*N!!!');
    return;
end
X=X(1:N,:);
X(:,1)=ceil(X(:,1).*scorescale);
minscore=min(X(:,1));
X(:,1)=X(:,1)+abs(minscore)+1;
id = [1:N];
id = id';

%mean(X)
%var(X)

selected=[1:N];
selected = selected'*.0;
sellocal=[1:N];
sellocal= sellocal'*0;
xtuplefile=sprintf('xid_%d_%1.2f_%d_%d',N,cor,numxtuple,xdegree);
xtuplefid = fopen(xtuplefile, 'wt');

X=sortrows(X, [-1 -2]);
udb=[id, X(:,1), X(:,2)];


for i=1:numxtuple
        succeed=0;
        while (succeed==0)
            A=rand(xdegree,1);
            A=ceil(A.*N);
            succeed=1;
            for j=1:xdegree
                 if (selected(A(j))~=0 || sellocal(A(j))~=0)
                     succeed=0;
                     break;
                 end
                 sellocal(A(j))=1;
            end
            for j=1:xdegree
                sellocal(A(j))=0;
            end
            if (succeed==1)
                A=sort(A);
                for j=1:xdegree
                  selected(A(j))=1;
                  fprintf(xtuplefid, '%8.0f ', A(j));
                end
                fprintf(xtuplefid, '\n');
            end
        end
        sumconf=0;
        for j=1:xdegree
            udb(A(j),1)=udb(A(1),1);
            sumconf=sumconf+abs(udb((A(j)),3));
        end
        for j=1:xdegree
            %confidence(A(j))=abs(confidence(A(j)))/sumconf;
            udb(A(j),3)=abs(udb(A(j),3))/sumconf;
        end
end
output=sprintf('xtuple_%d_%1.2f_%d_%d',N,cor,numxtuple,xdegree);
fid = fopen(output, 'wt');
fprintf(fid, '%8.0f %8.0f %1.4f\n', udb');
fclose(fid);
fclose(xtuplefid);
