//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <iostream>
#include <math.h>

#define ZERO 0.00001

using namespace::std;
class Tuple {
	public:
    Tuple();
    Tuple(unsigned int sortid, unsigned int id, unsigned int score, double confidence);
    Tuple(const Tuple& tp);
    ~Tuple(); 
    void show();
    void copy(Tuple& tp);
    friend ostream & operator<<( ostream &os, Tuple &tp);
    static unsigned long size(bool with_qitj)
    {
       if (!with_qitj)
           return 16; //id 4 byes, confidence 8 bytes, score 4 bytes.         
       else
           return 24; //id 4 byes, confidence 8 bytes, score 4 bytes, qitj 8 bytes         
    }
 
	public:
	unsigned int score;
	double confidence;
	unsigned int id;
	unsigned int sortid;
	double qitj;
	//id is the xtuple id, and sortid is the id (assigned in the order of sorted by score) each each tuple (break the x relations)
};
