//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>

using namespace::std;

class UkrankIndep {
	public:
    UkrankIndep(int k);
    ~UkrankIndep(); 
    bool initDB(unsigned int N, char* input_file);
	void findTopk();
	bool checkTerminate(vector<double> krank, vector<double>Rij);
	void printTopk();
	void printRij();
	void printStatistics();
	void getMemsize();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;

	vector<double> Rij;
	vector<unsigned int> topk;
	vector<double> krank;
	unsigned long memusage;
};
