//coded by Feifei Li, contact: lifeifei@cs.bu.edu


#include "tuple.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>

ostream & operator<<( ostream &os, Tuple &tp ) 
{ 
        os << tp.sortid<<" " << tp.id << " "<< tp.score << " " << tp.confidence; 
        return ( os ); 
}

Tuple::Tuple()
{
   this->score=0;
   this->confidence=0.0;     
   this->id=0;   
   this->sortid=0;   
   this->qitj=0.0;   
}

Tuple::Tuple(unsigned int sortid, unsigned int id, unsigned int score, double confidence)
{
   this->sortid=sortid;
   this->score=score;
   this->confidence=confidence;        
   this->id=id;   
   this->qitj=0.0;        
}

Tuple::Tuple(const Tuple& tp)
{
   this->sortid=tp.sortid;
   this->score=tp.score;
   this->confidence=tp.confidence;        
   this->id=tp.id;   
   this->qitj=tp.qitj;    
}

Tuple::~Tuple()
{}

void Tuple::show()
{
     std::cout<<this->id <<  " "<<this->score<<" "<<this->confidence<<std::endl;     
}

void Tuple::copy(Tuple& tp)
{
   this->sortid=tp.sortid;
   this->score=tp.score;
   this->confidence=tp.confidence;        
   this->id=tp.id;   
   this->qitj=tp.qitj;    
}
