//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#ifndef INCTUPLE
        #include "tuple.h"
        #define INCTUPLE 1
#endif
#include <sys/time.h>
#include <sys/times.h>

using namespace::std;


class Udb {
	public:
    Udb(unsigned int N, char* input_file);
    ~Udb(); 
    bool readRecords();
    void sortByScore();
    void printDB();
    unsigned int buildXtuples(char* file_input, int xdegree, unsigned int numxtuple);
    void printXtuple(unsigned int id); //only call this function after buildXtuple
    bool has_preceeding_alternative(unsigned int tp_sortid, bool& isxtuple);
    int timeval_subtract(struct timeval* result, struct timeval* x, struct timeval* y);


	public:
	unsigned int N;
	unsigned int numxtuple;
	int xdegree;
	std::ifstream fin;
	vector<Tuple> tuples;
	vector< vector<unsigned int> > xtuples;
};

