%coded by Feifei Li, contact: lifeifei@cs.bu.edu
function [udb] = indep_uniform_exp(N, scorescale, mean)
score = rand(N,1);
score(:, 1)=ceil(score(:,1)*scorescale);
id = [1:N];
confidence = exprnd(mean, 10*N, 1);
confidence = confidence(confidence(:,1)>0 & confidence(:,1)<=1, :);
confsize=size(confidence);
if (confsize(1,1)<N)
    printf('ERROR!!! Increase c value in c*N!!!');
    return;
end
confidence = confidence (1:N,:);
%udb=[id', score, confidence];
tmpudb=[score, confidence];
tmpudb=sortrows(tmpudb, [-1 -2]);
%udb=sortrows(udb, [-2 -3]);
udb=[id', tmpudb(:,1), tmpudb(:,2)];
output=sprintf('indep_ux_%d_%1.2f',N,mean);
fid = fopen(output, 'wt');
fprintf(fid, '%8.0f %8.0f %1.4f\n', udb');
fclose(fid);