%coded by Feifei Li, contact: lifeifei@cs.bu.edu
%sigma is std deviation
function [udb] = indep_uniform_normal(N, scorescale, avg, sigma)
score = rand(N,1);
score(:, 1)=ceil(score(:,1)*scorescale);
id = [1:N];
confidence = avg+sigma.*randn(10*N,1);
mean(confidence)
var(confidence)
confidence = confidence(confidence(:,1)>0 & confidence(:,1)<=1, :);
confsize=size(confidence);
if (confsize(1,1)<N)
    printf('ERROR!!! Increase c value in c*N!!!');
    return;
end
confidence = confidence (1:N,:);

%udb=[id', score, confidence];
tmpudb=[score, confidence];
tmpudb=sortrows(tmpudb, [-1 -2]);
udb=[id', tmpudb(:,1), tmpudb(:,2)];
output=sprintf('indep_un_%d_%1.2f_%1.2f',N,avg,sigma);
fid = fopen(output, 'wt');
fprintf(fid, '%8.0f %8.0f %1.4f\n', udb');
fclose(fid);