//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <iostream>
#include <math.h>


using namespace::std;
class Tuple {
	public:
    Tuple();
    Tuple(unsigned int sortid, unsigned int id, unsigned int score, double confidence);
    Tuple(const Tuple& tp);
    ~Tuple(); 
    void show();
    void copy(Tuple& tp);
    friend ostream & operator<<( ostream &os, Tuple &tp);
    static unsigned long size(bool with_qitj)
    {
           //id 4 byte, score 4 byte, confidence 8 byte, plus qitj 8 bytes if necessaryl;
           if (with_qitj)
              return 24;
           else
               return 16;       
    }
 
	public:
	unsigned int score;
	double confidence;
	unsigned int id;
	unsigned int sortid;
	double qitj;
	//id is the xtuple id, and sortid is the id (assigned in the order of sorted by score) each each tuple (break the x relations)
};
