//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "ukrankindep.h"

int main(int argc, char **argv)
{
	if (argc!=6)
	{
		cout<<"Usage: "<<argv[0]<<" input_file "<<" k "<<" N "<<" showDB(0,1) "<<" showTopk(0,1)"<<endl;
		return -1;
	}
    
	int k=atoi(argv[2]);
	unsigned int N=atoi(argv[3]);
	int showDB=atoi(argv[4]);
	int showTopk=atoi(argv[5]);

	UkrankIndep a(k);	
	a.initDB(N, argv[1]);
	if (showDB==1)
	{
	   a.db->printDB();
	   cout<<endl<<"UDB with N = "<<N<<" number of tuples "<<endl;
    }
	
	a.findTopk();
	
    if (showTopk==1)
	{
	   cout<<endl;
	   a.printTopk();
	   cout<<endl<<"Ukrank results for k= "<<k<<endl;
    }
    a.printStatistics();

    return 1;	
}
